#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace GridListDropDown
{
	/// <summary>
	/// Summary description for DropDownUser.
	/// </summary>
	public class DropDownUser : System.Windows.Forms.UserControl
	{
		public event EventHandler UserControlSave;
		public event EventHandler UserControlCancel;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.Button okButton;
        private GridListControl gridList;
        public GridModelSelections selections;
        public GridRangeInfoList list;
        public int[] selectedIndexList=null;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DropDownUser()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

            selections = new GridModelSelections(gridList.Grid.Model);
            list = new GridRangeInfoList();
            DataTable dt = this.CreateTable();
            gridList.DataSource = dt;
            gridList.DisplayMember = "col4";
            gridList.ValueMember = "col4";

            //display a single cell
//            gridList.MultiColumn = false;
		}

        
		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.panel1 = new System.Windows.Forms.Panel();
            this.cancelButton = new System.Windows.Forms.Button();
            this.okButton = new System.Windows.Forms.Button();
            this.gridList = new GridListControl();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.BackColor = System.Drawing.SystemColors.Control;
            this.panel1.Controls.Add(this.cancelButton);
            this.panel1.Controls.Add(this.okButton);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(154, 48);
            this.panel1.TabIndex = 2;
            // 
            // cancelButton
            // 
            this.cancelButton.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.cancelButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.cancelButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cancelButton.Location = new System.Drawing.Point(9, 11);
            this.cancelButton.Name = "cancelButton";
            this.cancelButton.Size = new System.Drawing.Size(59, 23);
            this.cancelButton.TabIndex = 1;
            this.cancelButton.Text = "Cancel";
            this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
            // 
            // okButton
            // 
            this.okButton.Anchor = System.Windows.Forms.AnchorStyles.None;
            this.okButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.okButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.okButton.Location = new System.Drawing.Point(80, 11);
            this.okButton.Name = "okButton";
            this.okButton.Size = new System.Drawing.Size(64, 23);
            this.okButton.TabIndex = 0;
            this.okButton.Text = "OK";
            this.okButton.Click += new System.EventHandler(this.okButton_Click);
            // 
            // gridList
            // 
            this.gridList.MultiColumn = true;
            this.gridList.FillLastColumn = true;
            this.gridList.SelectionMode = SelectionMode.MultiSimple;
            this.gridList.Location = new System.Drawing.Point(3, 3);
            this.gridList.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridList.Size = new System.Drawing.Size(154, 103);
            // 
            // DropDownUser
            // 
            this.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.Controls.Add(this.gridList);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.gridList);
            
            this.Name = "DropDownUser";
            this.Padding = new System.Windows.Forms.Padding(3);
            this.Size = new System.Drawing.Size(300, 250);
            this.AutoSize = true;
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

        public void SetValuesFromString(int[] indexes)
        {
            this.selectedIndexList = indexes;
        }

        public string GetValuesToString()
        {
            string val = "";
            val = this.gridList.SelectedValue.ToString();

            return val;
        }

        private void cancelButton_Click(object sender, System.EventArgs e)
        {
            gridList.Grid.Selections.Clear();
            foreach (int index in selectedIndexList)
                gridList.Grid.Selections.Ranges.Add(GridRangeInfo.Row(index));

            if (UserControlCancel != null)
                UserControlCancel(this, EventArgs.Empty);
        }

        private void okButton_Click(object sender, System.EventArgs e)
        {
            GridModelSelections selections = gridList.Grid.Selections;
            this.selectedIndexList = new int[selections.Count];
            for (int i = 0; i < selections.Count; i++)
            {
                this.selectedIndexList[i] = selections.Ranges[i].Top;
            }

            if (UserControlSave != null)
                UserControlSave(this, EventArgs.Empty);
        }

        #region Creating datatable
        private int numberOfRows = 10;
        private DataTable CreateTable()
        {
            DataTable dt1 = new DataTable("t1");
            dt1.Columns.Add("col1", typeof(int));
            dt1.Columns.Add("col2", typeof(int));
            dt1.Columns.Add("col3", typeof(int));
            dt1.Columns.Add("col4", typeof(int));

            DataRow dr = null;
            for (int i = 0; i < numberOfRows; i++)
            {
                dr = dt1.NewRow();
                for (int j = 0; j <= 3; j++)
                    dr[j] = i * 100 + j;
                dt1.Rows.Add(dr);
            }
            return dt1;
        }
        #endregion
	
	}
}
